package cz.muni.fi.pb162.project.geometry;

import cz.muni.fi.pb162.project.utils.SimpleMath;

/**
 * Class for working with Simple polygons
 *
 * @author Vitalii Bortsov
 */
abstract class SimplePolygon implements Polygon {

    /**
     * Method returns the difference between the largest and smallest Y coordinates in an polygon
     *
     * @return height of the polygon
     */
    public double getHeight() {
        return SimpleMath.maxY(this) - SimpleMath.minY(this);
    }

    /**
     * Method returns the difference between the largest and smallest X coordinates in an polygon
     *
     * @return width of the polygon
     */
    public double getWidth() {
        return SimpleMath.maxX(this) - SimpleMath.minX(this);
    }

    @Override
    public String toString() {
        final int verticesNum = this.getNumVertices();
        StringBuilder string = new StringBuilder("Polygon: vertices =");
        for (int i = 0; i < verticesNum; i++) {
            string.append(" ").append(this.getVertex(i));
        }
        return string.toString();
    }
}
